addHook("PlayerThink", function(player)
	if player.mo.skin != "metalsonic"
		return
	end
	
	if player.cmd.buttons & BT_CUSTOM1
		if not player.RSpActivate
			if not (player.mo.state == S_PLAY_RINGSPARK1)
			and not (player.mo.state == S_PLAY_RINGSPARK2)
				if P_IsObjectOnGround(player.mo)
				and not player.overdrivechargetimer
				and not player.dooverdriveattack
					player.mo.state = S_PLAY_RINGSPARK1
				end
			else
				player.mo.state = S_PLAY_RINGSPARK3
			end
		end
		player.RSpActivate = true
	else
		player.RSpActivate = false
	end
	
	if player.mo.state == S_PLAY_RINGSPARK2
		if leveltime % 2 == 0
			P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_RINGSPARKAURA)
		end
		
		if P_RandomRange(0, 2) == 2
			S_StartSound(player.mo, sfx_s3k5c)
		end
		
		player.normalspeed = 18*FRACUNIT
		player.pflags = $ & ~PF_SPINNING
	else
		if player.normalspeed == 18*FRACUNIT
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
	end
end)

addHook("PlayerCanDamage", function(p, mo)
	if p.mo.state == S_PLAY_RINGSPARK2
		return true
	end
end)

addHook("MobjCollide", function(spike, pmo)
	if not (pmo.player and pmo.player.valid) then return end
	if pmo.z+pmo.height < spike.z or spike.z+spike.height < pmo.z then return end
	
	if pmo.state == S_PLAY_RINGSPARK2
		P_KillMobj(spike, pmo, pmo)
	end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, pmo)
    if not (pmo.player and pmo.player.valid) then return end
    if (pmo.z > spike.z+spike.height*4) or (spike.z > pmo.z+pmo.height*2) then return end
	
	if pmo.state == S_PLAY_RINGSPARK2
		P_KillMobj(spike, pmo, pmo)
	end
end, MT_WALLSPIKE)

addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if target.player and target.player.valid
	and (target.state == S_PLAY_RINGSPARK2)
	and not (damagetype & DMG_DEATHMASK)
		return false
	end
end, MT_PLAYER)